﻿Global *m=AllocateMemory(65536)
Global *t=AllocateMemory(65536)
Global ad
Global adr$
Global s$
Global op$
Global org
Global ll
Global NewList labels.s()

Enumeration
  #data_code
  #data_byte
  #data_word
EndEnumeration

Enumeration
  #ds
  #rb
  #re
EndEnumeration

Enumeration
  #markbyte
  #markword
  #markcode
  
  #file_open
  #file_dis
  #file_save
  #file_quit
EndEnumeration

#MODEREG_MASK=$3f;	// mode And register mask
#OFFSET_MASK=$ff ;	// pc relative offset from instruction

Procedure.s tonum(nu,bas);number, numbase
  Select bas
    Case 2
      nb=2
      d$="01"
      ic=15 ;iteration count
    Case 8
      nb=8
      d$="01234567"
      ic=5
      ;       If nu<=255
      ;         ic=3
      ;       Else
      ;         ic=5
      ;       EndIf
    Case 10
      nb=10
      d$="0123456789"
      ic=4
    Case 16
      nb=16
      d$="0123456789ABCDEF"
      ic=3
  EndSelect
  r$=""
  num=nu
  For i=0 To ic
    r$=Mid(d$,nu%nb+1,1)+r$
    nu=Int(nu/nb)
    
  Next i
  
  If bas=8 And num<=255
    ;  Debug Mid(r$,1,1)
    While Len(r$)>=2 And Mid(r$,1,1)="0"
      r$=Mid(r$,2)
    Wend
  EndIf
  
  ProcedureReturn r$
EndProcedure

Procedure.s regname(n)
  n$="R"+Str(n)
  If n=6
    n$="SP"
  ElseIf n=7
    n$="PC"
  EndIf
  ProcedureReturn n$
EndProcedure

Procedure.s adrmode(src_reg,src_mode)
  ad$="UNDEFINED"
  Select src_mode
    Case 0;Register Rn
      ad$=regname(src_reg)
    Case 1;Register Deferred @Rn or (Rn)
      ad$="@"+regname(src_reg)
    Case 2
      If src_reg=7 ;#Immediate
        id=PeekU(*m+ad)
        s$=s$+" "+tonum(id,8)
        ad+2
        ad$="#"+tonum(id,8)
      Else;Autoincrement (Rn)+
        ad$="("+regname(src_reg)+")+"
      EndIf
    Case 3;Autoincrement Deferred @(Rn+)
      If src_reg=7;Immediate Deferred(Absolute)
        id=PeekU(*m+ad)
        ad+2
        ad$="@#"+tonum(id,8)
        s$=s$+" "+tonum(id,8)
      Else;autoincrement Deferred
        ad$="@("+regname(src_reg)+")+"
      EndIf
    Case 4;Autodecrement -(Rn)
      ad$="-("+regname(src_reg)+")"
    Case 5;Autodecrement Deferred @-(Rn)
      ad$="@-("+regname(src_reg)+")"
    Case 6
      If src_reg=7;relative A or X(PC)
        id=PeekU(*m+ad)
        s$=s$+" "+tonum(id,8)
        ad+2
        ad$="@"+tonum(id,8)
      Else;Index X(Rn) 6n
        id=PeekU(*m+ad)
        s$=s$+" "+tonum(id,8)
        ad+2
        ad$=tonum(id,8)+"("+regname(src_dest)+")"
      EndIf
    Case 7
      If src_reg=7;Index Deferred @X(Rn)
        id=PeekU(*m+ad)
        s$=s$+" "+tonum(id,8)
        ad+2
        ad$="@"+tonum(id,8)+"(PC)"
      Else;Index Deferred
        id=PeekU(*m+ad)
        s$=s$+" "+tonum(id,8)
        ad+2
        ad$="@"+tonum(id,8)+"("+regname(src_reg)+")"
      EndIf
  EndSelect
  ProcedureReturn ad$
EndProcedure

Procedure doOffset(adrs, offset)
  adrs=adrs+2
  If offset > $7f;		// negative offset
    dst.l = adrs - 2*(offset!255 +1);
  Else
    dst = adrs + offset*2;
  EndIf
  s$=s$+tonum(dst,8)
  ;op$=op$+" "+tonum(PeekU(*m+ad),8)
EndProcedure

Procedure.s doOperand(adrs,modereg);int doOperand(int adrs, int modereg)
                                   ;	int	mode, reg, dest;
  
  mode = modereg >> 3;
  reg = modereg & 7  ;
  
  ad$="UNDEFINED"
  Select mode;switch (mode)
    Case 0:  ;			// direct
      ad$=regname(reg);sprintf(temp, "r%d", reg);
      
    Case 1:;			// register deferred
      ad$="("+regname(reg)+")";sprintf(temp, "(r%d)", reg);
    Case 2:                   ;			// auto-increment Or immediate (r7)
      If (reg = 7)
        ad=ad+2;adrs++;
        ad$="#"+tonum(PeekU(*m+ad),8);sprintf(temp, "#%o", program[adrs]);
        op$=op$+" "+RSet(tonum(PeekU(*m+ad),8),6,"0")
      Else
        ad$="("+regname(reg)+")+";sprintf(temp, "(r%d)+", reg);
      EndIf
    Case 3:;			// auto-increment deferred Or absolute (r7)
      If reg = 7
        ad=ad+2
        ad$="@#"+tonum(PeekU(*m+ad),8)
        op$=op$+" "+RSet(tonum(PeekU(*m+ad),8),6,"0")
      Else
        ad$="@("+regname(reg)+")+";sprintf(temp, "@(r%d)+", reg);
      EndIf
    Case 4:;			// auto-decrement
      ad$="-("+regname(reg)+")";sprintf(temp, "-(r%d)", reg);
    Case 5:                    ;			// auto-decrement deferred
      ad$="@-("+regname(reg)+")";sprintf(temp, "@-(r%d)", reg);
    Case 6:                     ;			// index Or relative (r7)
      ad=ad+2
      If reg = 7
        ;       dest = PeekU(*m+ad)+2*ad+2;program[adrs] + 2 * adrs + 2;
        dest = PeekU(*m+ad)+ad+2;program[adrs] + 2 * adrs + 2;
        
        If dest > $FFFE;0177776)
          dest - 65536 ;0200000;
        EndIf
        
        ad$=tonum(dest,8);sprintf(temp, "%o", dest);
      Else
        ad$=tonum(PeekU(*m+ad),8)+"("+regname(reg)+")";sprintf(temp, "%o(r%d)", program[adrs], reg);
      EndIf
      
    Case 7:;			// index deferred Or relative deferred (r7)
      ad=ad+2
      
      If reg = 7
        dest = PeekU(*m+ad)+2*ad+2;)program[adrs] + 2 * adrs + 2;
        
        If dest > $FFFE;0177776)
          dest - 65536 ;0200000;
        EndIf
        ad$=tonum(dest,8);sprintf(temp, "@%o", dest);
      Else
        ad$="@"+tonum(PeekU(*m+ad),8)+"("+regname(reg)+")";sprintf(temp, "@%o(r%d)", program[adrs], reg);
      EndIf
  EndSelect;}//switch (mode)
  ProcedureReturn ad$
  ; 	strcat(outLine, temp);
  ; 	Return adrs;
EndProcedure;}//int doOperand(int adrs, int modereg)

Procedure invalid()
  Debug "invalid"
  End
EndProcedure

Procedure doFPOperand()
  iw=PeekU(*m+ad)
  acc = (iw >> 6) & 3;acc = (program[adrs] >> 6) & 3;
  mode = (iw >> 3) & 7;mode = (program[adrs] >> 3) & 7;
  reg = iw & 7        ;reg = program[adrs] & 7;
  
  If Not mode;If (!mode)
    s$=s$+" f"+Str(acc)+",";printf(temp, "\tf%d,", acc);		// mode != 0, restricted to AC0-AC3
                           ;strcat(outLine, temp);
    s$=s$+doOperand(ad, iw & #MODEREG_MASK);adrs = doOperand(adrs, program[adrs] & MODEREG_MASK);
  Else                                     ;		// actually, this makes no sense at all; there are only 2 bits for AC,
                                           ;{			// so it's not possible to access AC4-AC5
    s$=s$+" f"+Str(acc)+","                ;sprintf(temp, "\tf%d,", acc);
                                           ;strcat(outLine, temp);
    s$=s$+doOperand(ad, iw & #MODEREG_MASK);adrs = doOperand(adrs, program[adrs] & MODEREG_MASK);
  EndIf                                    ;}//If (!mode)
  
  ;	Return adrs;
EndProcedure;}//int doFPOperand(int adrs)

Procedure dis1()
  ; While ad<org+ll
  iw=PeekU(*m+ad)
  ;  s$=tonum(ad,8)+" "+tonum(iw,8)
  adr$=tonum(ad,8)
  s$=""
  op$=tonum(iw,8)
  
  ;huj=PeekA(*t+ad)
  Select PeekA(*t+ad)
    Case #data_byte
      s$=".byte "+tonum(PeekA(*m+ad),8)
      op$=tonum(PeekA(*m+ad),8)
      ad=ad+1
      If PeekA(*t+ad)=#data_byte
        s$=s$+","+tonum(PeekA(*m+ad),8)
        op$=op$+" "+tonum(PeekA(*m+ad),8)
        ad=ad+1
      EndIf
    Case #data_word
      s$=".word "+tonum(PeekU(*m+ad),8) 
      ad=ad+2
    Case #data_code
      Select (iw&$f000)>>12
        Case 0:;---------------------------group0---------------------------
          skipOperand=0				  
          Select (iw>>9)&7
            Case 0:;		// halt, wait, rti, bpt, iot, reset, rtt, jmp, rts, spl, nop, swab, br
                   ;---------------------------misc0---------------------------
              Select (PeekU(*m+ad)>>6)&7
                Case 0:;		// halt, wait, rti, bpt, iot, reset, rtt, mfpt
                  Select PeekU(*m+ad)
                    Case 0:
                      s$=s$+"HALT"
                      If PeekU(*m+ad+2);// If Not followed by another halt,
                        breakLine = 1  ;// do a blank line
                      EndIf
                    Case 1:
                      s$=s$+"WAIT"
                    Case 2:
                      s$=s$+"RTI"
                      breakLine = 1
                    Case 3:
                      s$=s$+"BPT"
                    Case 4:
                      s$=s$+"IOT"
                    Case 5:
                      s$=s$+"RESET"
                    Case 6:
                      s$=s$+"RTT"
                      breakLine = 1
                    Case 7:
                      s$=s$+"MFPT"
                    Default:
                      invalid();
                  EndSelect
                Case 1:;// jmp
                  s$=s$+"JMP "
                  s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
                  breakLine = 1
                Case 2:;		// rts, spl, nop, cond codes & unimplemented
                  If PeekU(*m+ad)<$88
                    reg = PeekU(*m+ad)&7
                    If reg<>7
                      s$=s$+"RTS "+regname(reg)
                    Else
                      s$=s$+"RET"
                    EndIf
                    breakLine = 1
                  ElseIf PeekU(*m+ad)<$98
                    invalid()
                  ElseIf PeekU(*m+ad)<$A0;// spl
                    s$=s$+"SPL "+tonum(PeekU(*m+ad)&7,8)
                  Else
                    If PeekU(*m+ad)=$A0
                      s$=s$+"NOP"
                    Else
                      Select PeekU(*m+ad);// condition codes
                        Case $A1
                          s$=s$+"CLC"
                        Case $A2
                          s$=s$+"CLV"
                        Case $A4
                          s$=s$+"CLZ"
                        Case $A8
                          s$=s$+"CLN"
                        Case $AF
                          s$=s$+"CCC"
                        Case $B1
                          s$=s$+"SEC"
                        Case $B2
                          s$=s$+"SEV"
                        Case B4
                          s$=s$+"SEZ"
                        Case $B8
                          s$=s$+"SEN"
                        Case $BF
                          s$=s$+"SCC"
                        Default:
                          invalid();
                      EndSelect
                    EndIf
                  EndIf
                Case 3:;		// swab
                  s$=s$+"SWAB "
                  s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK);
                Case 4:                                            ;		// br
                Case 5:
                Case 6:
                Case 7:
                  s$=s$+"BR "
                  doOffset(ad, PeekU(*m+ad) & #OFFSET_MASK)
                  breakLine = 1
              EndSelect
              ;---------------------------misc0---------------------------
            Case 1:;		// bne, beq
              If iw&256
                s$=s$+"BEQ "
              Else
                s$=s$+"BNE "
              EndIf
              doOffset(ad, PeekU(*m+ad)& #OFFSET_MASK);
            Case 2:                                   ;		// bge, blt
              If iw&256
                s$=s$+"BLT "
              Else
                s$=s$+"BGE "
              EndIf
              doOffset(ad, PeekU(*m+ad)& #OFFSET_MASK)
            Case 3:;		// bgt, ble
              If iw&256
                s$=s$+"BLE "
              Else
                s$=s$+"BGT "
              EndIf
              doOffset(ad, PeekU(*m+ad)& #OFFSET_MASK)
            Case 4:;		// jsr
              reg = (iw >> 6) & 7
              If (reg <> 7)
                s$=s$+"JSR "+regname(reg)+","
              Else
                s$=s$+"CALL "
              EndIf
              s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
            Case 5:;		// clr, com, inc, dec, neg, adc, sbc, tst
              Select (iw>>6)&7
                Case 0:
                  s$=s$+"CLR "
                Case 1:
                  s$=s$+"COM "
                Case 2:
                  s$=s$+"INC "
                Case 3:
                  s$=s$+"DEC "
                Case 4:
                  s$=s$+"NEG "
                Case 5:
                  s$=s$+"ADC "
                Case 6:
                  s$=s$+"SBC "
                Case 7:
                  s$=s$+"TST "
              EndSelect
              s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
            Case 6:;		// ror, rol, asr, asl, mark, mfpi, mtpi, sxt
              Select (iw>>6)&7
                Case 0:
                  s$=s$+"ROR "
                Case 1:
                  s$=s$+"ROL "
                Case 2:
                  s$=s$+"ASR "
                Case 3:
                  s$=s$+"ASL "
                Case 4:
                  s$=s$+"MARK "+tonum(iw&$3F,8)
                  skipOperand = 1
                Case 5:
                  s$=s$+"MFPI"
                Case 6:
                  s$=s$+" MTPI"
                Case 7:
                  s$=s$+" SXT"
              EndSelect
              
              If Not skipOperand
                s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              EndIf
            Case 7:;// invalid opcodes
              invalid();
          EndSelect
          ad=ad+2
          ;---------------------------group0---------------------------
        Case 1:
          ;---------------------------group1---------------------------
          s$=s$+"MOV "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)
          ad=ad+2
          ;---------------------------group1---------------------------
        Case 2:
          ;---------------------------group2---------------------------
          s$=s$+"CMP "
          modereg = PeekU(*m+ad)
          s$=s$+ doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK);
          ad=ad+2
          ;---------------------------group2---------------------------
        Case 3:
          ;---------------------------group3---------------------------
          s$=s$+"BIT "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK);
          ad=ad+2
          ;---------------------------group3---------------------------
        Case 4:
          ;---------------------------group4---------------------------
          s$=s$+"BIC "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+",";
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)           ;
          ad=ad+2
          ;---------------------------group4---------------------------
        Case 5:
          ;---------------------------group5---------------------------
          s$=s$+"BIS "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+",";
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)           ;
          ad=ad+2
          ;---------------------------group5---------------------------
        Case 6:
          ;---------------------------group6 add---------------------------
          s$=s$+"ADD "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK);
          ad=ad+2
          ;---------------------------group6---------------------------
        Case 7:
          ;---------------------------group7 register opcodes---------------------------
          code = (PeekU(*m+ad)>>9)&7
          reg = (PeekU(*m+ad)>>6)&7
          Select code
            Case 0:;		// mul
              s$=s$+"MUL "
              s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              s$=s$+","+regname(reg)
            Case 1:;		// div
              s$=s$+"DIV "
              s$=s$+ doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              s$=s$+","+regname(reg)
            Case 2:;		// ash
              s$=s$+"ASH "
              s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              s$=s$+","+regname(reg)
            Case 3:		;// ashc
              s$=s$+"ASHC "
              s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              s$=s$+","+regname(reg)
            Case 4:;		// XOr
              s$=s$+"XOR "
              s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              s$=s$+","+regname(reg)
            Case 5:;		// fadd, fskub, fmul, fdiv, And unimplemented
              If PeekU(*m+ad) >= $7A20
                invalid()
              Else
                code = (PeekU(*m+ad)>>3)&3
                iw=PeekU(*m+ad)
                Select code
                  Case 0:
                    s$=s$+"FADD "+regname(iw&7)
                  Case 1:
                    s$=s$+"FSUB "+regname(iw&7)
                  Case 2:
                    s$=s$+"FMUL "+regname(iw&7)
                  Case 3:
                    s$=s$+"FDIV "+regname(iw&7)
                EndSelect
              EndIf
              
            Case 6:;		// unimplemented
              invalid();
            Case 7:    ;		// sob
              offset = 2 * (adrs + 1) - 2 * (PeekU(*m+ad)&$3F)
              s$=s$+"SOB "+regname(reg)+","+tonum(offset,8)
          EndSelect
          ad=ad+2
          ;---------------------------group7---------------------------
        Case 8:
          ;---------------------------group8---------------------------
          ; branch opcodes + emt, trap, clrb, comb, incb, decb, negb, adcb, sbcb, tstb, rorb, rolb, asrb, aslb, mfpd, mtpd
          skipOperand = 0
          iw=PeekU(*m+ad)
          Select(iw>>9)&7
            Case 0:;		// bpl, bmi
              If iw&256
                s$=s$+"BMI "
              Else
                s$=s$+"BPL "
              EndIf
              doOffset(ad, iw & #OFFSET_MASK)
            Case 1:;// bhi, blos
              If iw&256
                s$=s$+"BLOS "
              Else
                s$=s$+"BHI "
              EndIf
              doOffset(ad, iw & #OFFSET_MASK)
            Case 2:;		// bvc, bvs
              If iw&256
                s$=s$+"BVS "
              Else
                s$=s$+"BVC "
              EndIf
              doOffset(ad, iw & #OFFSET_MASK)
            Case 3:;		// bcc, bhis, bcs, blo
              If iw&256
                s$=s$+"BCS "
              Else
                s$=s$+"BCC "
              EndIf
              doOffset(ad, iw & #OFFSET_MASK)
            Case 4:;		// emt, trap
              If iw<$8900
                s$=s$+"EMT "
              Else
                s$=s$+"TRAP "
              EndIf
              s$=s$+tonum(iw&255,8)
            Case 5:;		// clrb, comb, incb, decb, negb, adcb, sbcb, tstb
              code = (iw>>6)&7
              Select code
                Case 0:
                  s$=s$+"CLRB "
                Case 1:
                  s$=s$+"COMB "
                Case 2:
                  s$=s$+"INCB "
                Case 3:
                  s$=s$+"DECB "
                Case 4:
                  s$=s$+"NEGB "
                Case 5:
                  s$=s$+"ADCB "
                Case 6:
                  s$=s$+"SBCB "
                Case 7:
                  s$=s$+"TSTB "
              EndSelect
              s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
            Case 6:;		// rorb, rolb, asrb, aslb, mfpd, mtpd
              Select(PeekU(*m+ad)>>6)&7
                Case 0:
                  s$=s$+"RORB "
                Case 1:
                  s$=s$+"ROLB "
                Case 2:
                  s$=s$+"ASRB "
                Case 3:
                  s$=s$+"ASLB "
                Case 4:
                  s$=s$+"MTPS "
                Case 5:
                  s$=s$+"MFPD "
                Case 6:
                  s$=s$+"MTPD "
                Case 7:
                  s$=s$+"MFPS "
              EndSelect
              If Not skipOperand
                s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              EndIf
            Case 7:;		// invalid opcodes
              invalid();
          EndSelect
          ad=ad+2
          ;---------------------------group8---------------------------
        Case 9:
          ;---------------------------group9 movb opcodes---------------------------
          s$=s$+"MOVB "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)
          ad=ad+2
          ;---------------------------group9---------------------------
        Case $0a:
          ;---------------------------groupa cmpb opcodes---------------------------
          s$=s$+"CMPB "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)
          ad=ad+2
          ;---------------------------groupa---------------------------
        Case $0b:
          ;---------------------------groupbbitb opcodes---------------------------
          s$=s$+"BITB "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)
          ad=ad+2
          ;---------------------------groupb---------------------------
        Case $0c:
          ;---------------------------groupc bicb opcodes---------------------------
          s$=s$+"BICB "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)
          ad=ad+2
          ;---------------------------groupc---------------------------
        Case $0d:
          ;---------------------------groupd bisb opcodes---------------------------
          s$=s$+"BISB "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)
          ad=ad+2
          ;---------------------------groupd---------------------------
        Case $0e:
          ;---------------------------groupe sub opcodes---------------------------
          s$=s$+"SUB "
          modereg = PeekU(*m+ad)
          s$=s$+doOperand(ad, (modereg >> 6) & #MODEREG_MASK)+","
          s$=s$+doOperand(ad, modereg & #MODEREG_MASK)
          ad=ad+2
          ;---------------------------groupe---------------------------
        Case $0f:
          ;---------------------------groupf floating point opcodes---------------------------
          Select (PeekU(*m+ad)>>8)&15
            Case 00:                 ;	// setf, setd, seti, setl, ldfps, stfps, stst, cfcc
              Select PeekU(*m+ad)
                Case $F000
                  s$=s$+"CFCC "
                Case $F001
                  s$=s$+"TSETF "
                Case $F002 
                  s$=s$+"SETI "
                Case $F009
                  s$=s$+"SETD "
                Case $F00A
                  s$=s$+"SETL "
                Default:
                  Select (PeekU(*m+ad)>>6)&3
                    Case 0:
                      invalid();
                    Case 1:
                      s$=s$+"LDFPS "
                      s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
                    Case 2:
                      s$=s$+"STFPS "
                      s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
                    Case 3:
                      s$=s$+"STST "
                      s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
                  EndSelect
              EndSelect
            Case 01:;	// negf, negdm, clrf, clrd, absf, absd, tstf, tstd
              Select (PeekU(*m+ad)>>6)&3;switch (code)
                Case 0:
                  s$=s$+"CLRF "
                  s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
                Case 1:
                  s$=s$+"TSTF "
                  s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
                Case 2:
                  s$=s$+"ABSF "
                  s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
                Case 3:
                  s$=s$+"NEGF "
                  s$=s$+doOperand(ad, PeekU(*m+ad) & #MODEREG_MASK)
              EndSelect
            Case 02:;	// mulf, muld
              s$=s$+"MULT "
              doFPOperand()
            Case 03:;	// modf, modd
              s$=s$+"MODF "
              doFPOperand()
            Case 04:;	// addf, addd
              s$=s$+"ADDF "
              doFPOperand()
            Case 05:;	// ldf, ldd
              s$=s$+"LDF "
              doFPOperand()
            Case 06:;	// subf, subd
              s$=s$+"SUBF "
              doFPOperand()
            Case 07:;	// cmpf, cmpd
              s$=s$+"CMPF "
              doFPOperand()
            Case 08:;	// stf, std
              s$=s$+"STF "
              doFPOperand()
            Case 09:;	// divf, divd
              s$=s$+"DIVF "
              doFPOperand()
            Case $0a:;	// stexp
              s$=s$+"STEXP "
              doFPOperand()
            Case $0b:;	// stcfi, stcfl, stcdi, stcdl
            Case $0c:;	// stcfd, stcdf
              s$=s$+"STCDF "
              doFPOperand()
            Case $0d:;	// ldexp
              s$=s$+"LDEXP "
              doFPOperand()
            Case $0e:;	// ldcif, ldcid, ldclf, ldcld
              s$=s$+"LDCIF "
              doFPOperand()
            Case $0f:;	// ldcdf, ldcfd
              s$=s$+"LDCDF "
              doFPOperand()
          EndSelect
          ad=ad+2
          ;---------------------------groupf---------------------------
      EndSelect;Select (iw&$f000)>>12
               ;     Debug adr$+" "+s$+";"+op$
  EndSelect    ;Select PeekA(*t+ad)
  
  ;Wend
  
EndProcedure

Procedure scanoct(n$)
  num=0
  For i=1 To Len(n$)
    num=num*8+Val(Mid(n$,i,1))
  Next i
  ProcedureReturn num
EndProcedure

Procedure dis0()
  ClearGadgetItems(#ds)
  ClearList(labels())
  ad=org
  preva=org
  
  While ad<org+ll
    dis1()
    AddGadgetItem (#ds, -1,adr$+" "+s$+";"+op$)
    If preva<>ad
      preva=ad
    Else
      Break
    EndIf
  Wend
EndProcedure

Procedure markmem(v)
  im=GetGadgetState(#ds)
  If im<>-1
    madr=scanoct(Mid(GetGadgetItemText(#ds,im),1,6))
    PokeA(*t+madr,v)
    PokeA(*t+(madr+1)&$FFFF,v)
    dis0()
  EndIf
  
EndProcedure


If OpenWindow(0, 0, 0, 640, 480, "PDP11 disasm", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  If CreateMenu(1, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(#file_open, "Open...")
    MenuItem(#file_dis, "Disassemble")
    MenuItem(#file_save, "Save As...")
    MenuItem(#file_quit, "Quit")
  EndIf
  
  If CreatePopupMenu(0)      ; creation of the pop-up menu begins...
    MenuItem(#markbyte, "mark as byte pair")
    MenuItem(#markword, "mark as word")
    MenuItem(#markcode, "mark as code")
  EndIf
  
  ListViewGadget(#ds, 0, 20, 640, 400)
  StringGadget(#rb,0,0,310,20,"000000",#ES_CENTER|#ES_NUMBER)
  StringGadget(#re,320,0,310,20,"000002",#ES_CENTER|#ES_NUMBER)
  
  If LoadFont(1, "Courier", 10)
    SetGadgetFont(#ds,FontID(1))
  EndIf
  
  ;debug load
  FillMemory(*t,65535,#data_word,#PB_Byte)
  ReadFile(0,"draw.bin")
  org=ReadAsciiCharacter(0)+256*ReadAsciiCharacter(0)
  ll=ReadAsciiCharacter(0)+256*ReadAsciiCharacter(0)
  ad=org
  While Not Eof(0)
    PokeA(*m+ad,ReadAsciiCharacter(0))
    PokeA(*t+ad,#data_code)
    ad+1
  Wend
  CloseFile(0)
  SetGadgetText(#rb,tonum(org,8))    
  SetGadgetText(#re,tonum(org+ll,8))    
  ;
  dis0()
  Repeat
    ev=WaitWindowEvent()
    
    Select Ev
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #ds
            If EventType()=#PB_EventType_RightClick
              DisplayPopupMenu(0,WindowID(0))
            EndIf
        EndSelect
        
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_save
            itm=CountGadgetItems(#ds)
            If itm
              Pattern$ = "Text (*.txt)|*.txt"
              File$ = SaveFileRequester("Please choose file to save", GetCurrentDirectory(), Pattern$, 0)
              If File$
                If CreateFile(0,File$+".txt")
                  For ii=0 To itm
                    WriteStringN(0,GetGadgetItemText(#ds,ii))
                  Next ii
                  CloseFile(0)
                Else
                  MessageRequester("Error","Can't create"+#CRLF$+File$)
                EndIf;createfile
              EndIf  ;File$
            EndIf    ;itm
            
          Case #markword
            markmem(#data_word)
          Case #markcode
            markmem(#data_code)
          Case #markbyte
            markmem(#data_byte)
          Case #file_quit
            Break
        EndSelect
    EndSelect
    
  Until ev = #PB_Event_CloseWindow
EndIf


;dis1()


FreeMemory(*t)
FreeMemory(*m)
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 872
; FirstLine = 850
; Folding = ---
; EnableXP
; Debugger = IDE